package com.kingdee.eas.custom.performanceScoring.handler;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.bos.metadata.entity.SelectorItemCollection;
import com.kingdee.bos.metadata.entity.SelectorItemInfo;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.framework.CoreBaseInfo;
import com.kingdee.eas.hr.perf.PerformanProjectPersonFactory;
import com.kingdee.eas.hr.perf.PerformanProjectPersonInfo;
import com.kingdee.eas.hr.perf.PerformanProjectPersonPerfPlanMultipleCollection;
import com.kingdee.eas.hr.perf.PerformanProjectPersonPerfPlanMultipleInfo;
import com.kingdee.shr.base.syssetting.context.SHRContext;
import com.kingdee.shr.base.syssetting.exception.SHRWebException;
import com.kingdee.shr.base.syssetting.web.handler.DEPCustomBillEditHandler;
import com.kingdee.shr.base.syssetting.web.json.JSONUtils;
import com.kingdee.shr.perfweb.app.base.evalplan.IPerfPeriod;
import com.kingdee.shr.perfweb.app.base.evalplan.PerfPeriodCollection;
import com.kingdee.shr.perfweb.app.base.evalplan.PerfPeriodFactory;
import com.kingdee.shr.perfweb.app.base.evalplan.PerfPeriodInfo;
import com.kingdee.util.StringUtils;
import org.springframework.ui.ModelMap;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.HashMap;
import java.util.Map;

/**
 * ЧӦø_ ѡ
 * @Description TODO
 * @Date 2024/12/31 17:13
 * @Created by 30489
 */
public class PerformanProjectPersonDEPEditHandler extends DEPCustomBillEditHandler {


    /**
     *
     * @param request
     * @param response
     * @param modelMap
     * @return
     * @throws SHRWebException
     * @throws BOSException
     * @throws EASBizException
     */
    public String getPageDataAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap)
            throws SHRWebException, BOSException, EASBizException {
        String billId = request.getParameter("billId");
        Context context = SHRContext.getInstance().getContext();
        if (StringUtils.isEmpty(billId)) {
            return null;
        }
        Map<String, Object> map = new HashMap<String, Object>();
        SelectorItemCollection sic = new SelectorItemCollection();
        sic.add(new SelectorItemInfo("perfPlanStr"));
        sic.add(new SelectorItemInfo("PerfPlanMultiple.perfPlanMultiple.*"));
        PerformanProjectPersonInfo info = PerformanProjectPersonFactory.getLocalInstance(context)
                .getPerformanProjectPersonInfo(new ObjectUuidPK(billId), sic);

        PerformanProjectPersonPerfPlanMultipleCollection perfPlanMultiple = info.getPerfPlanMultiple();
        PerfPeriodCollection perfPeriodCollection = new PerfPeriodCollection();
        for (int i = 0; i < perfPlanMultiple.size(); i++) {
            PerformanProjectPersonPerfPlanMultipleInfo multipleInfo = perfPlanMultiple.get(i);
            PerfPeriodInfo perfPeriodInfo = multipleInfo.getPerfPlanMultiple();
            perfPeriodCollection.add(perfPeriodInfo);
        }
        map.put("perfPeriodCollection", perfPeriodCollection);
        map.put("perfPlanStr", info.getPerfPlanStr());

        JSONUtils.SUCCESS(map);
        return null;

    }

    @Override
    protected IObjectPK runSave(HttpServletRequest request, HttpServletResponse response, CoreBaseInfo model) throws Exception {

        PerformanProjectPersonInfo info = (PerformanProjectPersonInfo)model;
        Context context = SHRContext.getInstance().getContext();
        //Ч֯
        String perfPeriodIdCollections = (String) info.get("perforAppraisal");
        if (!StringUtils.isEmpty(perfPeriodIdCollections)) {
            String[] perfPeriodIdArr = perfPeriodIdCollections.split(",");
            IPerfPeriod localInstance = PerfPeriodFactory.getLocalInstance(context);
            //
            StringBuffer perfPeriodName = new StringBuffer();
            //ڱ
            StringBuffer perfPeriodNumber = new StringBuffer();
            //ڼ
            for (int i = 0; i < perfPeriodIdArr.length; i++) {
                //ЧӦøid¼
                PerformanProjectPersonPerfPlanMultipleInfo multipleInfo = new PerformanProjectPersonPerfPlanMultipleInfo();

                PerfPeriodInfo perfPeriodInfo = localInstance.getPerfPeriodInfo(new ObjectUuidPK(perfPeriodIdArr[i]));
                multipleInfo.setPerfPlanMultiple(perfPeriodInfo);
                info.getPerfPlanMultiple().add(multipleInfo);

                perfPeriodName.append(perfPeriodInfo.getName()).append("");
                perfPeriodNumber.append(perfPeriodInfo.getNumber()).append("");
            }
            perfPeriodName.deleteCharAt(perfPeriodName.length() - 1);
            //д뿼
            info.setPerfPlanStr(perfPeriodName.toString());
            //д뿼ڱ
            perfPeriodNumber.deleteCharAt(perfPeriodNumber.length() - 1);
            info.setPerfPlanNumber(perfPeriodNumber.toString());
            info.setDescription(perfPeriodIdCollections);
        }
        return super.runSave(request, response, model);
    }
}
