package com.kingdee.eas.custom.performanceScoring.handler;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.bos.metadata.entity.SelectorItemCollection;
import com.kingdee.bos.metadata.entity.SelectorItemInfo;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.framework.CoreBaseInfo;
import com.kingdee.eas.hr.perf.*;
import com.kingdee.shr.base.syssetting.context.SHRContext;
import com.kingdee.shr.base.syssetting.exception.SHRWebException;
import com.kingdee.shr.base.syssetting.web.handler.DEPCustomBillEditHandler;
import com.kingdee.shr.base.syssetting.web.json.JSONUtils;
import com.kingdee.shr.perfweb.app.base.evalplan.IPerfPeriod;
import com.kingdee.shr.perfweb.app.base.evalplan.PerfPeriodCollection;
import com.kingdee.shr.perfweb.app.base.evalplan.PerfPeriodFactory;
import com.kingdee.shr.perfweb.app.base.evalplan.PerfPeriodInfo;
import com.kingdee.util.StringUtils;
import org.springframework.ui.ModelMap;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.HashMap;
import java.util.Map;

/**
 * Ч_ ѡ
 * @Description TODO
 * @Date 2025/1/6 15:38
 * @Created by 30489
 */
public class PerformanProjectTwoDEPEditHandler extends DEPCustomBillEditHandler {
    /**
     *
     * @param request
     * @param response
     * @param modelMap
     * @return
     * @throws SHRWebException
     * @throws BOSException
     * @throws EASBizException
     */
    public String getPageDataAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap)
            throws SHRWebException, BOSException, EASBizException {
        String billId = request.getParameter("billId");
        Context context = SHRContext.getInstance().getContext();
        if (StringUtils.isEmpty(billId)) {
            return null;
        }
        Map<String, Object> map = new HashMap<String, Object>();
        SelectorItemCollection sic = new SelectorItemCollection();
        sic.add(new SelectorItemInfo("perfPlanName"));
        sic.add(new SelectorItemInfo("PerfPlanTwo.perfPlan.*"));
        PerformanProjectTwoInfo info = PerformanProjectTwoFactory.getLocalInstance(context)
                .getPerformanProjectTwoInfo(new ObjectUuidPK(billId), sic);

        PerformanProjectTwoPerfPlanTwoCollection perfPlanTwo = info.getPerfPlanTwo();
        PerfPeriodCollection perfPeriodCollection = new PerfPeriodCollection();
        for (int i = 0; i < perfPlanTwo.size(); i++) {
            PerformanProjectTwoPerfPlanTwoInfo planTwoInfo = perfPlanTwo.get(i);
            PerfPeriodInfo perfPeriodInfo = planTwoInfo.getPerfPlan();
            perfPeriodCollection.add(perfPeriodInfo);
        }
        map.put("perfPeriodCollection", perfPeriodCollection);
        map.put("perfPlanStr", info.getPerfPlanName());

        JSONUtils.SUCCESS(map);
        return null;
    }

    @Override
    protected IObjectPK runSave(HttpServletRequest request, HttpServletResponse response, CoreBaseInfo model) throws Exception {

        PerformanProjectTwoInfo info = (PerformanProjectTwoInfo)model;
        Context context = SHRContext.getInstance().getContext();
        //Ч֯
        String perfPeriodIdCollections = (String) info.get("perforAppraisal");
        if (!StringUtils.isEmpty(perfPeriodIdCollections)) {
            String[] perfPeriodIdArr = perfPeriodIdCollections.split(",");
            IPerfPeriod localInstance = PerfPeriodFactory.getLocalInstance(context);//
            //
            StringBuffer perfPeriodName = new StringBuffer();
            boolean a = true;
            //ڱ
            StringBuffer perfPeriodNumber = new StringBuffer();
            //ڼ
            for (int i = 0; i < perfPeriodIdArr.length; i++) {
                //ЧӦøid¼
                PerformanProjectTwoPerfPlanTwoInfo planTwoInfo = new PerformanProjectTwoPerfPlanTwoInfo();

                PerfPeriodInfo perfPeriodInfo = localInstance.getPerfPeriodInfo(new ObjectUuidPK(perfPeriodIdArr[i]));
                planTwoInfo.setPerfPlan(perfPeriodInfo);
                info.getPerfPlanTwo().add(planTwoInfo);

                perfPeriodName.append(perfPeriodInfo.getName()).append("");
                perfPeriodNumber.append(perfPeriodInfo.getNumber()).append("");
            }
            perfPeriodName.deleteCharAt(perfPeriodName.length() - 1);
            //д뿼
            info.setPerfPlanName(perfPeriodName.toString());
            //д뿼ڱ
            perfPeriodNumber.deleteCharAt(perfPeriodNumber.length() - 1);
            info.setPerfPlanNumber(perfPeriodNumber.toString());
            info.setDescription(perfPeriodIdCollections);
        }
        return super.runSave(request, response, model);
    }
}
